// ==========================================================================
// APPLY.MPS : Sample new user process MPL program
//
// If APPLY.MPE exists in the theme's script directory or the fallback
// directory, it will be ran instead of the normal New User process.  You
// must make sure you scan for duplicate user names, and other things like
// that which the BBS would normally do during this process.  At the start
// of the program, you must call GetThisUser to load the new user data into
// the USER variables.  Before exiting the program, you must call PutThisUser
// to store the USER variables back into the new user data.
//
// Note: To use this program, you must rename it to APPLY.MPS and compile it
// with MIDE or MPLC.
// ==========================================================================

Uses
  User

Procedure GetHandle;
Var
  Str : String[30];
Begin
  Repeat
    Write ('Enter your alias: ');

    Str := strStripLow(strStripB(GetStr(30, 30, 1, ''), ' '));

    If IsUser(Str) Then
      WriteLn ('Account already exists')
    Else
      Break;
  Until False;

  UserHandle := Str;
End;

Procedure GetRealName;
Var
  Str : String[30];
Begin
  Repeat
    Write ('Enter your real name: ');

    Str := strStripLow(strStripB(GetStr(30, 30, 1, ''), ' '));

    If Pos(' ', Str) = 0 Then
      WriteLn ('Enter first AND last name')
    Else
    If IsUser(Str) Then
      WriteLn ('Account already exists')
    Else
      Break;
  Until False;

  UserName := Str;
End;

Procedure GetPassword;
Var
  Str1 : String[20];
  Str2 : String[20];
Begin
  Repeat
    Repeat
      Write ('Enter your password: ');

      Str1 := GetStr(20, 20, 6, '');

      If Length(Str1) < 4 Then
        WriteLn ('Password must be at least 4 chars')
      Else
        Break;
    Until False;

    Write ('Verify your password: ');

    Str2 := GetStr(20, 20, 6, '');

    If Str1 <> Str2 Then
      WriteLn ('Passwords do not match.')
    Else
      Break;
  Until False;

  UserPW := Str1;
End;

Begin
  GetThisUser;

  GetHandle;
  GetRealName;
  GetPassword;

  PutThisUser;
End.
