// ==========================================================================
// ONELINER.MPS                                               Coded by g00r00
// --------------------------------------------------------------------------
// Simple oneliners script written for Mystic BBS 2.0.  Various options and
// prompts can be setup by changing the values of the Const variables listed
// below.  If you want to add external headers, you can use the DF MCI code
// inside of the Header prompt, etc.
// ==========================================================================

Const
  MaxOneLiners   = 15          // MAX ONE LINERS TO ALLOW
  InputFieldSize = 75          // LENGTH OF INPUT FIELD
  NameOffset     = 4           // OFFSET FOR PROMPT MIDDLE. FIGURE IT OUT! =]
  AllowAnonymous = True        // ALLOW ANONYMOUS POSTS
  UseInitials    = False       // USE INITIALS INSTEAD OF NAMES?
  LoopAfterAdd   = True        // RELOAD ONELINERS AFTER ADDING
  DefaultYes     = False       // ADD QUESTION DEFAULTS TO YES?

  PromptHeader    = '|CL|15Oneliners|CR|08|$D79|CR'
  PromptMiddle    = '|15|&A |07>> |03|&B'
  PromptFooter    = '|08|$D79|CR'
  PromptAskAdd    = '|12Do you want to add a oneliner? |11'
  PromptAnonymous = '|12Post anonymously? |11'
  PromptEnterText = '|CR|09Enter your oneliner (Blank/Abort)|CR:'

// ==========================================================================

Uses
  Cfg,
  User;

Procedure AddNewEntry;
Var
  Str      : String;
  Count    : Byte;
  ListSize : Byte;
  ListData : Array[1..MaxOneLiners] of String;
  ListFile : File;
Begin
  ListSize := 0;

  fAssign (ListFile, JustPath(ProgName) + 'oneliner.dat', 2);
  fReset  (ListFile);

  If IoResult = 0 Then Begin
    While Not fEof(ListFile) And ListSize < MaxOneLiners Do Begin
      ListSize := ListSize + 1;
      fReadLn (ListFile, ListData[ListSize]);
    End;

    fClose (ListFile);

    If ListSize = MaxOneLiners Then Begin
      For Count := 1 to MaxOneLiners - 1 Do
        ListData[Count] := ListData[Count + 1];

      ListSize := MaxOneLiners - 1;
    End;
  End;

  Write (PromptEnterText);

  Str := GetStr(InputFieldSize, 79 - Length(UserHandle) - NameOffset, -1, '');

  If Str <> '' Then Begin
    ListSize           := ListSize + 1;
    ListData[ListSize] := PromptMiddle;
    ListData[ListSize] := strReplace(ListData[ListSize], '|&A', UserHandle);
    ListData[ListSize] := strReplace(ListData[ListSize], '|&B', Str);

    fReWrite (ListFile);

    For Count := 1 to ListSize Do
      fWriteLn (ListFile, ListData[Count]);

    fClose (ListFile);
  End;
End;

Var
  Str : String;
Begin
  GetThisUser;

:Start

  Write    (PromptHeader);
  DispFile (JustPath(ProgName) + 'oneliner.dat');
  Write    (PromptFooter);

  If GetYN(PromptAskAdd, DefaultYes) Then Begin
    If AllowAnonymous Then
      If GetYN(PromptAnonymous, False) Then
        UserHandle := 'Anonymous';

    If UseInitials Then
      If UserHandle = 'Anonymous' Then
        UserHandle := '??'
      Else Begin
        Str := strInitials(UserHandle);
        If Length(Str) < 2 Then Str := Copy(UserHandle, 1, 2);
      End;

    AddNewEntry;

    If LoopAfterAdd Then Goto Start;
  End;
End.
