procedure testcase;
var
  number : longint;
  num2   : longint;
  num3   : longint;
  num4   : real;
begin
  write ('Testing CASE statement... ')

  number := 73;
  num2   := 13;
  num3   := -1;
  num4   := 12.12;

  case number of
    68     : begin
               writeln('number is 68!');
             end
    69     : writeln('number is 69!');
    70, 71 : writeln('number is 70 or 71');
    72..80 : begin
               case num2 of
                 10 : writeln('num2 = 10');
                 11 : begin
                        writeln('num2 = 11');
                      end;
                 13 : case num3 of
                       -1: begin
                             case num4 of
                               12.12: begin
                                        writeln('PASSED');
                                      end;
                             end;
                           end;
                      end;
               else begin
                 writeln('num2 is something else');
               end;
             end;
  else
    writeln('number is not found!');
  end;
end;

procedure testgoto
begin
  write('Testing GOTO statement... ')
  goto start
:uphere
  writeln('PASSED');
  goto end
:start
  goto uphere
:end
end;

procedure testnumbers;
var
  num1,
  num2 : longint;
  num3 : array[1..10] of byte;
  num4 : array[1..10, 1..10, 1..10] of byte;
begin
  write ('Testing NUMBERS... ');

  num1        := 2 + 12 * 2;
  num2        := -10;
  num3[1]     := 50;
  num4[1,1,1] := (6 - 1) + 5 * 4;

  if (num2 = -10) and (num1 = 26) and (num2 = -10) and (num3[1] = 50) and
     (num4[1,1,1] = 25) then
    writeln('PASSED')
  else
    writeln('FAILED');
end;

procedure testrecords;
type
  testrec = record
    x : byte;
    y : byte;
    d : array[1..10] of string[12];
  end;
var
  blah : byte;
  test : testrec;
begin
  Write ('Testing RECORDS... ');

  test.x    := 1;
  test.y    := 2;
  test.d[1] := 'hello'

  if (test.x = 1) and (test.y = 2) and (test.d[1] = 'hello') then
    writeln ('PASSED')
  else
    writeln ('FAILED')
end;

procedure testprocedures;

  procedure testproc1;

    procedure testproc2
    begin
      WriteLn ('PASSED')
    end;

  begin
    testproc2
  end;

begin
  Write ('Testing PROCEDURES... ');
  testproc1;
end;

procedure testrecursive (loop:byte)
begin
  If loop = 255 then
    write('Testing RECURSIVE...');

  loop := loop - 1;

  if loop > 1 then
    testrecursive(loop)
  else
    writeln('PASSED')
end;

procedure testfunctions;

  function testfunc1 (p1,p2:byte; p3:string) : byte;
  begin
    if (p1 <> 10) or (p2 <> 5) or (p3 <> 'hello') then
      testfunc1 := 5
    else
      testfunc1 := 10;
  end;

{$syntax iplc}
  func testfunc2 : string {
    testfunc2 = "ok"
  }

{$syntax pascal}

begin
  Write ('Testing FUNCTIONS... ');

  if (testfunc1(10, 5, 'hello') = 10) and (testfunc2 = 'ok') then
    writeln ('PASSED')
  else
    writeln ('FAILED')
end;

procedure testvarpassing;

  procedure testit (var str: string);
  begin
    str := str + ' world';
  end;

var
  str : string;
begin
  write ('Testing VARPASSING... ');
  str := 'hello';
  testit(str);
  if str = 'hello world' then
    writeln ('PASSED')
  else
    writeln ('FAILED');
end;

procedure teststringindex;
var
  str : string;
begin
  write ('Testing STRING IDX...');
  str := 'hello world';
  str[6] := #33;
  if (str[1] = str[1]) and (str[2] = #101) and (str[6] = '!') then
    writeln ('PASSED')
  else
    writeln ('FAILED')
end;

procedure testloops;
var
  count1 : byte;
  count2 : byte;
  count3 : byte;
begin
 Write ('Testing LOOPS...');

 count1 := 0;
 while count1 < 100 do begin
   count1 := count1 + 1;
   if count1 = 10 then break;
 end;

 count2 := 0;
 repeat
  count2 := count2 + 1;
  if count2 = 10 then break;
 until count2 = 100;

 for count3 := 1 to 100 do
   if count3 = 10 then break;

 if (count1 = 10) and (count2 = 10) and (count3 = 10) then
   writeln ('PASSED')
 else
   writeln ('FAILED');
end;

procedure testconsts;
const
  const1 = 'hello';
  const2 = true;
var
  str1 : string;
  bol1 : boolean;
  ok1  : boolean;
  ok2  : boolean;
begin
  write ('Testing CONSTS...');

  ok1  := false;
  ok2  := false;
  str1 := 'hello';
  bol1 := true;

  case str1 of
    const1 : ok1 := true;
  end;

  case bol1 of
    const2 : ok2 := true;
  end;

  if ok1 and ok2 then
    writeln ('PASSED')
  else
    writeln ('FAILED')
end;

procedure testsyntaxparsing;

{$syntax iplc}
  proc testiplc {
    @ byte test1, test2, test3 = 10;
    write ("PASS");
    @ string anywhere = "we can do this wherever..."
  }

{$syntax pascal}
  procedure testpascal;
  var
    test1, test2, test3 : byte = 10;  // um.. not a pascal standard!
  begin
    writeln('ED');
    var anywhere : string = 'wait!  pascal doesn''t allow this!';
  end;

begin
  write ('Testing SYNTAX... ');
  testiplc;
  testpascal;
end;

begin
  clrscr;
  writeln ('Mystic BBS Programming Language Test Module');
  writeln ('');

  testcase;
  testgoto;
  testnumbers;
  testrecords;
  testprocedures;
  testfunctions;
  testrecursive(255);
  testvarpassing;
  teststringindex;
  testloops;
  testconsts;
  testsyntaxparsing;
end
